local mapMod = foundation.createMod();

-- registering map files
mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")

-- register custom map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "COLONY_NOTFLAT",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -45,
	MaxHeight = 130,
	VillagePathList = {
		{
			Entrance = { 71, 0, 980 },
			Exit = { 73, 0, 57 },
		},
		{
			Entrance = { 174, 0, 973 },
			Exit = { 228, 0, 73 },
		},
		{
			Entrance = { 264, 0, 987 },
			Exit = { 365, 0, 81 },
		},
		{
			Entrance = { 384, 0, 994 },
			Exit = { 427, 0, 56 },
		},
		{
			Entrance = { 516, 0, 987 },
			Exit = { 491, 0, 51 },
		},
		{
			Entrance = { 611, 0, 917 },
			Exit = { 582, 0, 69 },
		},
		{
			Entrance = { 706, 0, 974 },
			Exit = { 673, 0, 68 },
		},
		{
			Entrance = { 782, 0, 954 },
			Exit = { 780, 0, 54 },
		},
		{
			Entrance = { 856, 0, 969 },
			Exit = { 900, 0, 13 },
		},
		{
			Entrance = { 983, 0, 975 },
			Exit = { 965, 0, 51 },
		},
		{
			Entrance = { 20, 0, 915 },
			Exit = { 981, 0, 997 },
		},
		{
			Entrance = { 49, 0, 977 },
			Exit = { 964, 0, 866 },
		},
		{
			Entrance = { 37, 0, 856 },
			Exit = { 963, 0, 798 },
		},
		{
			Entrance = { 932, 0, 767 },
			Exit = { 25, 0, 784 },
		},
		{
			Entrance = { 27, 0, 714 },
			Exit = { 960, 0, 676 },
		},
		{
			Entrance = { 30, 0, 627 },
			Exit = { 945, 0, 597 },
		},
		{
			Entrance = { 61, 0, 533 },
			Exit = { 1007, 0, 548 },
		},
		{
			Entrance = { 41, 0, 455 },
			Exit = { 966, 0, 486 },
		},
		{
			Entrance = { 43, 0, 347 },
			Exit = { 999, 0, 392 },
		},
		{
			Entrance = { 39, 0, 275 },
			Exit = { 1008, 0, 318 },
		},
		{
			Entrance = { 40, 0, 208 },
			Exit = { 991, 0, 213 },
		},
		{
			Entrance = { 42, 0, 125 },
			Exit = { 943, 0, 124 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 917, 3, 77 },
			Orientation = { 0 , -38, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 924, 10, 92 },
			Orientation = { 0 , 0, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 962, 9, 250 },
			Orientation = { 0 , -92, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 381, 7, 52 },
			Orientation = { 0 , 0, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 368, 6, 48 },
			Orientation = { 0 , -36, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 287, 11, 113 },
			Orientation = { 0 , -68, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 165, 7, 265 },
			Orientation = { 0 , 0, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 99, 17, 767 },
			Orientation = { 0 , 46, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 94, 24, 802 },
			Orientation = { 0 , -164, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 475, 45, 669 },
			Orientation = { 0 , 15, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 542, 39, 766 },
			Orientation = { 0 , 0, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 610, 38, 779 },
			Orientation = { 0 , -65, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 340, 22, 690 },
			Orientation = { 0 , -96, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 718, 26, 634 },
			Orientation = { 0 , -69, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 838, 29, 863 },
			Orientation = { 0 , 159, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 16
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 138, 30, 702 },
			Orientation = { 0 , -159, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 17
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 817, 5, 284 },
			Orientation = { 0 , -147, 0 },
			PatchBeforeVersion = "1.1.1"
		},
		{
			-- creating Mineral Deposit 18
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 808, 8, 294 },
			Orientation = { 0 , -109, 0 },
			PatchBeforeVersion = "1.1.1"
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
